---
title: ':optional'
slug: 'Web/CSS/:optional'
tags:
  - CSS
  - Layout
  - Pseudo-class
  - Reference
  - Selector
  - Web
---
<div>{{ CSSRef }}</div>

<p>The <strong><code>:optional</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> represents any {{HTMLElement("input")}}, {{HTMLElement("select")}}, or {{HTMLElement("textarea")}} element that does not have the {{ htmlattrxref("required", "input") }} attribute set on it.</p>

<pre class="brush: css no-line-numbers notranslate">/* Selects any optional &lt;input&gt; */
input:optional {
  border: 1px dashed black;
}</pre>

<p>This pseudo-class is useful for styling fields that are not required to submit a form.</p>

<div class="note">
<p><strong>Note:</strong> The {{cssxref(":required")}} pseudo-class selects <em>required</em> form fields.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="The_optional_field_has_a_purple_border">The optional field has a purple border</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;div class="field"&gt;
    &lt;label for="url_input"&gt;Enter a URL:&lt;/label&gt;
    &lt;input type="url" id="url_input"&gt;
  &lt;/div&gt;

  &lt;div class="field"&gt;
    &lt;label for="email_input"&gt;Enter an email address:&lt;/label&gt;
    &lt;input type="email" id="email_input" required&gt;
  &lt;/div&gt;
&lt;/form&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">label {
  display: block;
  margin: 1px;
  padding: 1px;
}

.field {
  margin: 1px;
  padding: 1px;
}

input:optional {
  border-color: rebeccapurple;
  border-width: 3px;
}
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Examples', 600, 120)}}</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>If a <a href="/en-US/docs/Web/HTML/Element/form">form</a> contains optional {{htmlelement("input")}}s, required inputs should be indicated using the {{ htmlattrxref("required", "input") }} attribute. This will ensure that people navigating with the aid of assistive technology such as a screen reader will be able to understand which inputs need valid content to ensure a successful form submission.</p>

<p>Required inputs should also be indicated visually, using a treatment that does not rely solely on color to convey meaning. Typically, descriptive text and/or an icon are used.</p>

<ul>
	<li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Understandable#Guideline_3.3_%E2%80%94_Input_Assistance_Help_users_avoid_and_correct_mistakes">MDN Understanding WCAG, Guideline 3.3 explanations</a></li>
	<li><a href="https://www.w3.org/TR/UNDERSTANDING-WCAG20/minimize-error-cues.html">Understanding Success Criterion 3.3.2 | W3C Understanding WCAG 2.0</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{ SpecName('HTML WHATWG', '#selector-optional', ':optional') }}</td>
			<td>{{ Spec2('HTML WHATWG') }}</td>
			<td>No change.</td>
		</tr>
		<tr>
			<td>{{ SpecName('HTML5 W3C', '#selector-optional', ':optional') }}</td>
			<td>{{ Spec2('HTML5 W3C') }}</td>
			<td>Defines the semantics of HTML and constraint validation.</td>
		</tr>
		<tr>
			<td>{{ SpecName('CSS4 Selectors', '#opt-pseudos', ':optional') }}</td>
			<td>{{ Spec2('CSS4 Selectors') }}</td>
			<td>No change.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.selectors.optional")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>Other validation-related pseudo-classes: {{ cssxref(":required") }}, {{ cssxref(":invalid") }}, {{ cssxref(":valid") }}</li>
	<li><a href="/en-US/docs/Learn/HTML/Forms/Form_validation">Form data validation</a></li>
</ul>
